diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index 7c2fc09f4..e17638089 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -15,24 +15,18 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ParticleBlockBreaking extends Particle {
-    private Block<?> block;
-    private Side side;
+    private final Block<?> block;
+    private final Side side;
     private final @NotNull TilePos initPos = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
     public ParticleBlockBreaking(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
         super(world, x, y, z, xa, ya, za);
-        this.reset(world, x, y, z, xa, ya, za, block, side, meta);
-    }
-
-    public ParticleBlockBreaking reset(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
-        super.resetBase(world, x, y, z, xa, ya, za);
         this.side = side;
         this.block = block;
         this.tex = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
         this.gravity = block.blockParticleGravity;
         this.rCol = this.gCol = this.bCol = 0.6F;
         this.size /= 2.0F;
-        return this;
     }
 
     public ParticleBlockBreaking init(@NotNull TilePosc tilePos) {
@@ -63,23 +57,26 @@ public class ParticleBlockBreaking extends Particle {
 
     @Override
     public byte calcLightIndex(float partialTick) {
+        class Cache {
+            private static final @NotNull TilePos queryPos = new TilePos();
+            private static final @NotNull TilePos blockPos = new TilePos();
+        }
+
         if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
-        TilePos blockPos = new TilePos(
+        Cache.blockPos.set(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick));
 
         byte lightIndex = 0;
-        if (this.world.getBlockLitInteriorSurface(blockPos) || blockPos.equals(initPos)) {
-            TilePos queryPos = new TilePos();
-
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
-            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
+        if (this.world.getBlockLitInteriorSurface(Cache.blockPos) || Cache.blockPos.equals(this.initPos)) {
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(Cache.blockPos.up(Cache.queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(Cache.blockPos.west(Cache.queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(Cache.blockPos.east(Cache.queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(Cache.blockPos.south(Cache.queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(Cache.blockPos.north(Cache.queryPos)));
         } else {
-            lightIndex = this.world.getSavedLightIndex(blockPos);
+            lightIndex = this.world.getSavedLightIndex(Cache.blockPos);
         }
 
         return lightIndex;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
index 659823227..68516117b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
@@ -8,6 +7,7 @@ import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 
 public class ParticleBubble extends Particle {
+
     private final boolean needsWater;
 
     public ParticleBubble(World world, double x, double y, double z, double xa, double ya, double za, @NotNull Dimension dimension, boolean needsWater) {
@@ -16,7 +16,7 @@ public class ParticleBubble extends Particle {
         this.rCol = 1.0F;
         this.gCol = 1.0F;
         this.bCol = 1.0F;
-        this.tex = dimension == Dimension.NETHER ? TextureRegistry.getTexture("minecraft:particle/bubble_boiling") : TextureRegistry.getTexture("minecraft:particle/bubble");
+        this.tex = dimension == Dimension.NETHER ? ParticleTextureCache.ICON_BUBBLE_BOILING : ParticleTextureCache.ICON_BUBBLE;
         this.size = this.size * (random.nextFloat() * 0.6F + 0.2F);
         this.xd = xa * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
         this.yd = ya * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
@@ -26,6 +26,7 @@ public class ParticleBubble extends Particle {
 
     @Override
     public void tick() {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
@@ -35,10 +36,10 @@ public class ParticleBubble extends Particle {
         this.xd *= 0.85D;
         this.yd *= 0.85D;
         this.zd *= 0.85D;
-        if (this.needsWater && this.world.getBlockMaterial(new TilePos(this.x, this.y, this.z)) != Materials.WATER) {
+        if (this.lifetime-- <= 0) {
             remove();
         }
-        if (this.lifetime-- <= 0) {
+        if (this.needsWater && this.world.getBlockMaterial(Cache.queryPos.set(this.x, this.y, this.z)) != Materials.WATER) {
             remove();
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
index 125f24332..5197e85c3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubbleBoiling.java
@@ -1,20 +1,14 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
-import org.jetbrains.annotations.NotNull;
 
 public class ParticleBubbleBoiling extends Particle {
     private float sinTimer = 0;
-    private boolean isReversed = false;
+    private final boolean isReversed;
     private final boolean needsWater;
-//    private final AABBd aabbd = new AABBd();
-    private final TilePos qpos = new TilePos();
-    private final @NotNull IconCoordinate popping = TextureRegistry.getTexture("minecraft:particle/bubble_boiling_pop");
 
     public ParticleBubbleBoiling(World world, double x, double y, double z, double xa, double ya, double za, boolean needsWater) {
         super(world, x, y, z, xa, ya, za);
@@ -22,7 +16,7 @@ public class ParticleBubbleBoiling extends Particle {
         this.rCol = 1.0F;
         this.gCol = 1.0F;
         this.bCol = 1.0F;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble_boiling");
+        this.tex = ParticleTextureCache.ICON_BUBBLE_BOILING;
         this.size = this.size * (random.nextFloat() * 0.7F + 0.3F);
         this.xd = xa * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
         this.yd = ya * 0.2D + (Math.random() * 2D - 1.0D) * 0.02F;
@@ -34,6 +28,10 @@ public class ParticleBubbleBoiling extends Particle {
 
     @Override
     public void tick() {
+        class Cache {
+            private static final TilePos queryPos = new TilePos();
+//            private static final AABBd aabbd = new AABBd();
+        }
         this.sinTimer++;
         if (this.sinTimer > 100) {
             this.sinTimer = 0;
@@ -43,10 +41,10 @@ public class ParticleBubbleBoiling extends Particle {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        final double expand = 0.05;
-//        this.aabbd.setMin(this.x - expand, this.y - expand, this.z - expand).setMax(this.x + expand, this.y, this.z + expand);
-//        boolean inWater = this.world.isAABBInMaterial(this.qpos, Materials.WATER);
-        boolean inWater = this.world.getBlockMaterial(this.qpos.set((int) this.x, (int) (this.y), (int) this.z)) == Materials.WATER;
+//        final double expand = 0.05;
+//        Cache.aabbd.setMin(this.x - expand, this.y - expand, this.z - expand).setMax(this.x + expand, this.y, this.z + expand);
+//        boolean inWater = this.world.isAABBInMaterial(Cache.qpos, Materials.WATER);
+        boolean inWater = this.world.getBlockMaterial(Cache.queryPos.set(this.x, this.y, this.z)) == Materials.WATER;
         if (inWater) {
             this.yd = 0.20D;
 
@@ -63,8 +61,8 @@ public class ParticleBubbleBoiling extends Particle {
             this.lifetime = MathHelper.clamp(this.lifetime, 0, 8);
         }
         if (this.lifetime == 6) {
-            this.tex = this.popping;
-            world.spawnParticle("smoke", x, y, z, 0.0D, 0.0D, 0.0D, 1, false);
+            this.tex = ParticleTextureCache.ICON_BUBBLE_BOILING_POP;
+            this.world.spawnParticle("smoke", this.x, this.y, this.z, 0.0D, 0.0D, 0.0D, 1, false);
         } else if (this.lifetime <= 0) {
             remove();
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
index e449080c7..f29a4d7d0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 
 public class ParticleExplode extends Particle {
@@ -23,12 +22,7 @@ public class ParticleExplode extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.yd += 0.004D;
         move(this.xd, this.yd, this.zd);
         this.xd *= 0.9D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
index 53bcb7bef..ded9c16fa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
@@ -1,8 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.util.helper.LightIndexHelper;
@@ -43,7 +41,7 @@ public class ParticleFirefly extends Particle {
         this.lifetime = (int) (24D + random.nextInt(6));
         this.lifetime *= (int) scale;
         this.noPhysics = false;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/firefly");
+        this.tex = ParticleTextureCache.ICON_FIREFLY;
         if (random.nextInt(2) == 0) {
             this.isReversed = true;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
index b5b6b997b..7e96784df 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
@@ -83,8 +83,9 @@ public class ParticleFluidDrip extends Particle {
 
     @Override
     public byte calcLightIndex(float partialTick) {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         if (this.fullBright) {
-            return LightIndexHelper.lightIndex2i(this.world.getSavedLightValue(LightLayer.Sky, new TilePos(this.x, this.y, this.z)), 15);
+            return LightIndexHelper.lightIndex2i(this.world.getSavedLightValue(LightLayer.Sky, Cache.queryPos.set(this.x, this.y, this.z)), 15);
         }
         return super.calcLightIndex(partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
index b7af7e7af..cb953a275 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -23,7 +22,7 @@ public class ParticleHeart extends Particle {
         this.oSize = this.size;
         this.lifetime = 16;
         this.noPhysics = false;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/heart");
+        this.tex = ParticleTextureCache.ICON_HEART;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
index cda09824a..5431ed214 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -19,7 +18,7 @@ public class ParticleLava extends Particle {
         this.oSize = this.size;
         this.lifetime = (int) (16D / (Math.random() * 0.8D + 0.2D));
         this.noPhysics = false;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble_lava");
+        this.tex = ParticleTextureCache.ICON_BUBBLE_LAVA;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index c06799116..de44ba8fc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLeavesBase;
@@ -13,9 +14,10 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
 public class ParticleLeaf extends Particle {
+    private static final @NotNull IconCoordinate ICON_OAK_LEAVES = TextureRegistry.getTexture("minecraft:block/leaves/oak_fancy");
     public ParticleLeaf(World world, double x, double y, double z, double xa, double ya, double za) {
         super(world, x, y, z, xa, ya, za);
-        this.tex = TextureRegistry.getTexture("minecraft:block/leaves/oak_fancy");
+        this.tex = ICON_OAK_LEAVES;
         this.gravity = 0.125F;
         this.size /= 2.0F;
         this.lifetime *= 16;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
index 3f44568c7..ee1aa6c51 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
@@ -1,8 +1,6 @@
 package net.minecraft.client.render.particle;
 
-
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -28,7 +26,7 @@ public class ParticleNote extends Particle {
         this.oSize = this.size;
         this.lifetime = 6;
         this.noPhysics = false;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/note");
+        this.tex = ParticleTextureCache.ICON_NOTE;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
index c091499d3..51da06bcf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePickupAnimation.java
@@ -6,6 +6,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
 
 public class ParticlePickupAnimation extends Particle {
     private final Entity item;
@@ -25,6 +26,7 @@ public class ParticlePickupAnimation extends Particle {
 
     @Override
     public void renderLit(float partialTick, double xOff, double yOff, double zOff) {
+        class Cache { private static final @NotNull TilePos queryPos = new TilePos(); }
         float time = (this.life + partialTick) / this.lifeTime;
         time *= time;
         double xo = this.item.x;
@@ -36,11 +38,11 @@ public class ParticlePickupAnimation extends Particle {
         double xx = xo + (xt - xo) * time;
         double yy = yo + (yt - yo) * time;
         double zz = zo + (zt - zo) * time;
-        TilePos tilePos = new TilePos(xx, yy, zz);
+        Cache.queryPos.set(xx, yy, zz);
         xx -= xOff;
         yy -= yOff;
         zz -= zOff;
-        GLRenderer.setLightmapCoord1i(this.item.world.getLightIndex(tilePos, 0));
+        GLRenderer.setLightmapCoord1i(this.item.world.getLightIndex(Cache.queryPos, 0));
         GLRenderer.setColor4f(1f, 1f, 1f, 1f);
         EntityRendererDispatcher.instance.renderEntityWithPosYaw(GLRenderer.getTessellator(), this.item, (float) xx, (float) yy, (float) zz, this.item.yRot, partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
index f063bd052..bf7f22437 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.world.World;
@@ -30,7 +29,7 @@ public class ParticlePortal extends Particle {
         this.bCol *= color.getBlue() / 255f;
         this.lifetime = (int) (Math.random() * 10D) + 40;
         this.noPhysics = true;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + (int) (Math.random() * 8D));
+        this.tex = ParticleTextureCache.ICON_PUFF_STAGES[(int) (Math.random() * ParticleTextureCache.ICON_PUFF_STAGES.length)];
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
index aed803848..da21927f2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
@@ -10,7 +9,7 @@ import org.jetbrains.annotations.NotNull;
 
 public class ParticlePuffRGB extends Particle {
     private final float oSize;
-    private int brightness;
+    private final int brightness;
 
     public ParticlePuffRGB(World world, double x, double y, double z, float red, float green, float blue, int brightness) {
         this(world, x, y, z, 1.0F, red, green, blue, brightness);
@@ -18,10 +17,7 @@ public class ParticlePuffRGB extends Particle {
 
     public ParticlePuffRGB(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
-        this.brightness = -1;
-        if (brightness >= 0) {
-            this.brightness = brightness;
-        }
+        this.brightness = brightness >= 0 ? brightness : -1;
         this.xd *= 0.1D;
         this.yd *= 0.1D;
         this.zd *= 0.1D;
@@ -39,14 +35,8 @@ public class ParticlePuffRGB extends Particle {
 
     @Override
     public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
-        float l = ((this.age + partialTick) / this.lifetime) * 32F;
-        if (l < 0.0F) {
-            l = 0.0F;
-        }
-        if (l > 1.0F) {
-            l = 1.0F;
-        }
-        this.size = this.oSize * l;
+        float s = MathHelper.clamp(((this.age + partialTick) / this.lifetime) * 32F, 0, 1);
+        this.size = this.oSize * s;
         if (this.tex == null) return;
         int xTile = MathHelper.floor(this.x);
         int yTile = MathHelper.floor(this.y);
@@ -63,7 +53,7 @@ public class ParticlePuffRGB extends Particle {
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
-            this.tex.getIconUMin() + this.tex.getIconUSize(), this.tex.getIconVMin(), this.tex.getIconUSize() , this.tex.getIconVSize());
+            this.tex.getIconUMin(), this.tex.getIconVMin(), this.tex.getIconUSize(), this.tex.getIconVSize());
     }
 
     @Override
@@ -75,12 +65,7 @@ public class ParticlePuffRGB extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.move(this.xd, this.yd, this.zd);
         if (this.y == this.yo) {
             this.xd *= 1.1D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
index 2ba5837e9..312e74cfa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
@@ -1,8 +1,6 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
@@ -86,12 +84,7 @@ public class ParticleRedstoneDust extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.move(this.xd, this.yd, this.zd);
         if (this.y == this.yo) {
             this.xd *= 1.1D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRubyglassLightning.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRubyglassLightning.java
index 24c67e917..d27fe6c9a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRubyglassLightning.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRubyglassLightning.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -49,6 +50,10 @@ public class ParticleRubyglassLightning extends Particle{
 
     @Override
     public void renderLit(float partialTick, double camOffX, double camOffY, double camOffZ) {
+        class Cache {
+            private static final double @NotNull [] xOffs = new double[8];
+            private static final double @NotNull [] zOffs = new double[8];
+        }
         TessellatorGeneral t = GLRenderer.getTessellator();
         GLRenderer.pushFrame();
         GLRenderer.setLightmapCoord1i(this.cachedLightmapCoord);
@@ -61,15 +66,14 @@ public class ParticleRubyglassLightning extends Particle{
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE);
 
-        final double @NotNull [] xOffs = new double[8];
-        final double @NotNull [] zOffs = new double[8];
+
         double xOff = 0.0D;
         double zOff = 0.0D;
 
         rand.setSeed(this.seed);
         for (int h = 7; h >= 0; h--) {
-            xOffs[h] = xOff;
-            zOffs[h] = zOff;
+            Cache.xOffs[h] = xOff;
+            Cache.zOffs[h] = zOff;
             xOff += rand.nextInt(11) - 5;
             zOff += rand.nextInt(11) - 5;
         }
@@ -87,8 +91,8 @@ public class ParticleRubyglassLightning extends Particle{
                     ht = hs - 2;
                 }
 
-                double xo0 = xOffs[hs] - xOff;
-                double zo0 = zOffs[hs] - zOff;
+                double xo0 = Cache.xOffs[hs] - xOff;
+                double zo0 = Cache.zOffs[hs] - zOff;
 
                 // h = segment
                 for (int h = hs; h >= ht; h--) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
index 0e0ab3ff5..eaea83f52 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.particle;
 
 import net.minecraft.client.render.tessellator.TessellatorParticle;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -31,14 +31,8 @@ public class ParticleSmoke extends Particle {
 
     @Override
     public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
-        float l = ((this.age + partialTick) / this.lifetime) * 32F;
-        if (l < 0.0F) {
-            l = 0.0F;
-        }
-        if (l > 1.0F) {
-            l = 1.0F;
-        }
-        this.size = this.oSize * l;
+        float s = MathHelper.clamp(((this.age + partialTick) / this.lifetime) * 32F, 0, 1);
+        this.size = this.oSize * s;
         super.render(tessellatorParticle, partialTick);
     }
 
@@ -50,12 +44,7 @@ public class ParticleSmoke extends Particle {
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
-        int val = (7 - ((this.age * 8) / this.lifetime));
-        if (val >= 0) {
-            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
-        } else {
-            this.tex = null;
-        }
+        this.tex = ParticleTextureCache.getPuffStage(this.age, this.lifetime);
         this.yd += 0.004D;
         this.move(this.xd, this.yd, this.zd);
         if (this.y == this.yo) {
